#ifndef __ClassZ_Header
#define __ClassZ_Header

#include <iostream>
using std::cout;
#include <memory> // wegen shared_ptr
using std::unique_ptr;

class Z {
public:
   Z(int id = 9) : m_id(id) {
      cout << "+Z" << id << " ";
   }
   ~Z() {
      cout << "-Z" << m_id << " ";
   }
   Z(const Z& z2) :m_id(z2.m_id) {
      cout << "+ZC" << m_id << " ";
   }
   void use() const {
      cout << "use:" << m_id << " ";
   }
private:
   int m_id;
};
#endif /* __ClassRZ_Header */

